//
// Sample of using Async reading of Dallas Temperature Sensors
// 
#include <OneWire.h>
#include <DallasTemperature.h>

// Data wire is plugged into port 2 on the Arduino
#define ONE_WIRE_BUS 2

// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);

// Pass our oneWire reference to Dallas Temperature. 
DallasTemperature sensors(&oneWire);

DeviceAddress tempDeviceAddress;

int  resolution = 12;
int real_current = 0;
int heating_power = 0;
int PWM = 0;
unsigned long lastTempRequest = 0;
int  delayInMillis = 0;
float temperature = 0.0;
float set_point = 70;   //0-125 Celcius
int  idle = 0;
//
// SETUP
//
void setup(void)
{
  Serial.begin(115200);
  Serial.println("Dallas Temperature Control Library - Async Demo");
  Serial.print("Library Version: ");
  Serial.println(DALLASTEMPLIBVERSION);
  Serial.println("\n");

  sensors.begin();
  sensors.getAddress(tempDeviceAddress, 0);
  sensors.setResolution(tempDeviceAddress, resolution);   //nustatomna 12 bitu rezoliucija  4096 750ms apklauinejimas
  sensors.setWaitForConversion(false);
  sensors.requestTemperatures();

  
  pinMode(3, OUTPUT);   //apkrova
//  pinMode(A2, input);   //input
//  pinMode(A5, input);   //input
  delay(750);
}

void loop(void)
{ 
    Serial.print("Current A2: "); //vienas countas 50ma + 150 countu triuksmas
    real_current=abs(((analogRead(A2)-220)*50)); //nuimamams triuksmas   ir padauginama ir 50mA
//    real_current=analogRead(A2); //countais   
    Serial.print(real_current); 
    Serial.print("mA");
    heating_power=real_current*0.001*12;
    Serial.print(" Heating power: ");
    Serial.print(heating_power); 
    Serial.print("W");
    sensors.requestTemperatures();
    Serial.print(" Temperature: ");
    temperature = sensors.getTempCByIndex(0);
    Serial.print(temperature); 
    Serial.print("  Resolution: ");
    Serial.print(resolution);   
    Serial.print("  Set point: ");
    Serial.print(set_point);   
    Serial.print("  PWM: ");
    Serial.print(PWM);   
    Serial.println(); 
    
    delay(750);

    if(set_point>temperature && PWM<255 && PWM>=0) {
                              PWM=PWM+5;
                              analogWrite(3, PWM); 
                              }
    if(set_point<temperature && PWM<=255 && PWM>0) {
                              PWM=PWM-5;
                              analogWrite(3, PWM);   
                              }
            
}
